<?php
//include("response.php");
?>  

<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.0/css/bootstrap.min.css">
<script type="text/javascript" charset="utf8" src="http://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.8.2.min.js"></script>
<link rel="stylesheet" href="dist/style.min.css" />
<script src="dist/jstree.min.js"></script>
<title>jsTree Source Code : Simple Example to add,edit and delete using jsTree,php and MySQL</title>
</head>
<body>
<div class="container">
<div><h3>jsTree Demo : Simple Example to create tree structure using jsTree,php and MySQL</h1></div>
<div id="tree-container" style="padding:21px 60px;"></div>
</div>
</body>
</html>
<script type="text/javascript">
$(document).ready(function(){ 
    //fill data to tree  with AJAX call
    $('#tree-container').jstree({
        'core' : {
			'data' : {
							'url' : 'response.php?operation=get_node',
							'data' : function (node) {
								return { 'id' : node.id };
							},
							"dataType" : "json"
						}
            ,'check_callback' : true,
						'themes' : {
							'responsive' : false
						}
			},
			'plugins' : ['state','contextmenu','wholerow']
		}).on('create_node.jstree', function (e, data) {
		          
					$.get('response.php?operation=create_node', { 'id' : data.node.parent, 'position' : data.position, 'text' : data.node.text })
						.done(function (d) {
							data.instance.set_id(data.node, d.id);
						})
						.fail(function () {
							data.instance.refresh();
						});
				}).on('rename_node.jstree', function (e, data) {
					$.get('response.php?operation=rename_node', { 'id' : data.node.id, 'text' : data.text })
						.fail(function () {
							data.instance.refresh();
						});
				}).on('delete_node.jstree', function (e, data) {
					$.get('response.php?operation=delete_node', { 'id' : data.node.id })
						.fail(function () {
							data.instance.refresh();
						});
				});
});
</script>